;---------------------------------------------------------------------------
;       nC][hp
;---------------------------------------------------------------------------
ifdef   F_PMODE

GetFontDataH    PROC   near
                push    ax

                mov     bx,offset FontData72
                mov     ah,1Fh
                int     18h
                
                push    cs
                pop     es
                mov     di,offset FontData72
                xor     ax,ax
                mov     cx,64/2
         rep    scasw

                pop     ax
                or      cx,cx
                jnz     @f
                stc
                ret
        @@:     
                mov     di,offset VECT_DATA_AREA
                add     di,ax
                mov     si,offset FontData72
                mov     cx,64/2
         rep    movsw

                mov     ax,0FFFFh
                mov     di,offset FontData72
                mov     cx,64/2
         rep    stosw

                clc
                ret
GetFontDataH    ENDP

LoadFromGaiji_H PROC   near
         ;(64byte )    JIScode  
                ; vect 00-0F    
                mov     dx,7650h
                mov     ax,(00h*4)
                call    GetFontDataH ; ItZbg0063(3Fh)  
                jc      Gaiji_H_error

                mov     si,offset FontData72
                mov     ax,[si+40h]      ; ItZbg64(40h)̈ʒu

                mov     es,cs:Seg0000
                mov     es:[0401h],al
                mov     es:[0594h],ah
                mov     ax,[si+42h]   ; ItZbg66(42h)̈ʒu
                mov     es:[05A7h],al
                mov     es:[05B6h],ah

                ; vect 10-1F
                mov     dx,7651h
                mov     ax,(10h*4)
                call    GetFontDataH
                jc      Gaiji_H_error
if 1
                ; vect 20-2F
                mov     dx,7652h
                mov     ax,(20h*4)
                call    GetFontDataH
                jc      Gaiji_H_error2


                ; vect 30-3F
                mov     dx,7653h
                mov     ax,(30h*4)
                call    GetFontDataH
                jc      Gaiji_H_error2

                ; vect 40-4F
                mov     dx,7654h
                mov     ax,(40h*4)
                call    GetFontDataH
                jc      Gaiji_H_error2

                ; vect 50-5F
                mov     dx,7655h
                mov     ax,(50h*4)
                call    GetFontDataH
                jc      Gaiji_H_error2

                ; vect 60-6F
                mov     dx,7656h
                mov     ax,(60h*4)
                call    GetFontDataH
                jc      Gaiji_H_error2

                ; vect 70-7F
                mov     dx,7657h
                mov     ax,(70h*4)
                call    GetFontDataH
                jc      Gaiji_H_error2
endif
                clc
Gaiji_H_error:  
                ret
Gaiji_H_error2: clc
                ret
LoadFromGaiji_H ENDP

ENDIF

ifdef   SAVE_GAIJI       
;---------------------------------------------------------------------------

UploadFontDataH PROC   near     ; (CS)ES:DI=FontData72wĂ
                mov     di,offset FontData72 ;(CS=DS)
                mov     si,offset VECT_DATA_AREA
                add     si,ax   ; AXŗ^ꂽItZbg
                mov     cx,64/2 ; 64oCgRs[
        rep     movsw           ; i[hPʂŁj
                mov     bx,offset FontData72 ; ɒl̓ZbgĂ
                mov     ah,20h  ; DISPLAY BIOS @\20hĂяo
                int     18h
                ret
UploadFontDataH endp

;---------------------------------------------------------------------------
; xN^00h-7Fhi512oCgjۑ邱ƂɂB
; nC]tHgł͊R[hP72oCg؂肪B
; 64oCgPʁixN^16jɂB 512648 pӂ΂悢B
; R[h765Fh܂ŋĂ̂ 7650`765F gƂɂB
; 7650̒[8oCg SYSTEM ʈ8oCgi4oCg`ς݁jɎgB
;   FontData72 `64oCg`  72oCg
;---------------------------------------------------------------------------
SaveToGaiji_H   PROC   near
                push    cs
                pop     es      ; ES=CS
                mov     di,offset FontData72 ;(CS=DS)

                push    ds      ; VXeʈ̃f[^Ɏ擾
                mov     ds,cs:Seg0000
                mov     al,ds:[0401h]
                mov     ah,ds:[0594h]
                mov     cs:[di+40h],ax   ; ItZbg64(40h)̈ʒuɕۑ
                mov     al,ds:[05A7h]
                mov     ah,ds:[05B6h]
                mov     cs:[di+42h],ax   ; ItZbg66(42h)̈ʒuɕۑ
                pop     ds

         ;(64byte )    JIScode  
                ; vect 00-0F    
                mov     dx,7650h
                mov     ax,(00h*4)
                call    UploadFontDataH ; ItZbg0063(3Fh)  

                xor     ax,ax
                mov     di,offset FontData72 ;(CS=DS)
                mov     [di+40h],ax   ; ItZbg64(40h)̈ʒuɕۑ
                mov     [di+42h],ax   ; ItZbg66(42h)̈ʒuɕۑ

                ; vect 10-1F
                mov     dx,7651h
                mov     ax,(10h*4)
                call    UploadFontDataH
if 1
                ; vect 20-2F
                mov     dx,7652h
                mov     ax,(20h*4)
                call    UploadFontDataH

                ; vect 30-3F
                mov     dx,7653h
                mov     ax,(30h*4)
                call    UploadFontDataH

                ; vect 40-4F
                mov     dx,7654h
                mov     ax,(40h*4)
                call    UploadFontDataH

                ; vect 50-5F
                mov     dx,7655h
                mov     ax,(50h*4)
                call    UploadFontDataH

                ; vect 60-6F
                mov     dx,7656h
                mov     ax,(60h*4)
                call    UploadFontDataH

                ; vect 70-7F
                mov     dx,7657h
                mov     ax,(70h*4)
                call    UploadFontDataH
endif

                RET
SaveToGaiji_H   ENDP

endif
