
;----------------------------------------2022/2/3--------------------
;       CheckCPU386     ȈՂCPU386        NC=386, CY below 386
;--------------------------------------------------------------------
CheckCPU386     PROC   near;  ϐ CPUtype  x=0..6
                pushf
                pop     ax
                pushf
                or      ax,4000h
                push    ax
                popf
                pushf
                pop     ax
                popf
                and     ax,0C000h
                cmp     ax,4000h
                jNe     Not386
                mov     ax,0300h
                mov     cs:CPUtype,AH
                clc
                ret
Not386:         
                pushf
                pop     ax
                test    ax,8000h
                jnz     Not286
                mov     ax,0200h
                mov     cs:CPUtype,ah
                stc
                ret
Not286:         mov     ax,0100h
                DB      0D5h,00h        ; AAD 00(V30)    AAD(intel)
                jz      NotV30          ; AL=0          AL=0Ah
                mov     ax,0100h        ; V30 ̒l 0100h Ƃ
                mov     cs:CPUtype,ah
NotV30:
                stc
                ret
CheckCPU386     ENDP
;--------------------------------------2022/2/1-----
;       CheckEPSONPC
;---------------------------------------------------
CheckEPSONPC    PROC   near
                xor     ax,ax
                mov     es,ax
                mov     ax,0FD80h       ; seg
                mov     bx,0002h        ; ofs
                mov     cx,2A27h        ; EPSON 27h,2Ah (Normal)
                test    byte ptr es:[0501h],8
                jz      EpsonNormalMode
                mov     ax,0F800h       ; seg
                mov     bx,07F70h       ; ofs
                mov     cx,1827h        ; EPSON 27h,18h (Hireso)
EpsonNormalMode:  
                mov     es,ax
                cmp     es:[bx],cx      ; compare
                je      IsEPSONPC
                clc
                ret
IsEPSONPC:      
                mov     al,es:[3]       ; EPSON ID
                mov     ah,0
                or      cs:flagset,F_EPSON
                stc     ; CY=EPSON PC
                ret
CheckEPSONPC    ENDP

;--------------------------------------2022/2/1------
;       CheckEPSON286   EPSON 286`FbN
;----------------------------------------------------
CheckEPSON286   PROC   near
                cmp     cs:CPUtype,2
                jb      NotEPSON
MaybeEPSON:     mov     dx,0C03h ; EPSON 286 original RAM control port
                in      al,dx
                xchg    al,ah
                jmp     $+2
                jmp     $+2
                mov     dx,0C09h ; EPSON 286 original RAM control port
                in      al,dx
                cmp     ax,0FFFFh
                je      NotEPSON
IsEPSON:
                or      cs:flagset,F_EPSON
                stc     ; CY=EPSON 286
                ret
NotEPSON:       clc     ; NC=others
                ret
CheckEPSON286   ENDP

